java.beans

## Class SimpleBeanInfo

- java.lang.Object
- - java.beans.SimpleBeanInfo

- All Implemented Interfaces:
    BeanInfo

      public class SimpleBeanInfo
      extends Object
      implements BeanInfo

  This is a support class to make it easier for people to provide BeanInfo classes.

  It defaults to providing "noop" information, and can be selectively overriden to provide more explicit information on chosen topics. When the introspector sees the "noop" values, it will apply low level introspection and design patterns to automatically analyze the target bean.

- - ### Field Summary

    - ### Fields inherited from interface java.beans.BeanInfo

      `ICON_COLOR_16x16, ICON_COLOR_32x32, ICON_MONO_16x16, ICON_MONO_32x32`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleBeanInfo()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `BeanInfo[]` | `getAdditionalBeanInfo()` Claim there are no other relevant BeanInfo objects.
    `BeanDescriptor` | `getBeanDescriptor()` Deny knowledge about the class and customizer of the bean.
    `int` | `getDefaultEventIndex()` Deny knowledge of a default event.
    `int` | `getDefaultPropertyIndex()` Deny knowledge of a default property.
    `EventSetDescriptor[]` | `getEventSetDescriptors()` Deny knowledge of event sets.
    `Image` | `getIcon(int iconKind)` Claim there are no icons available.
    `MethodDescriptor[]` | `getMethodDescriptors()` Deny knowledge of methods.
    `PropertyDescriptor[]` | `getPropertyDescriptors()` Deny knowledge of properties.
    `Image` | `loadImage(String resourceName)` This is a utility method to help in loading icon images.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SimpleBeanInfo

          public SimpleBeanInfo()

  - ### Method Detail

    - #### getBeanDescriptor

          public BeanDescriptor getBeanDescriptor()

      Deny knowledge about the class and customizer of the bean. You can override this if you wish to provide explicit info.
      Specified by:
        `getBeanDescriptor` in interface `BeanInfo`
      Returns:
        A BeanDescriptor providing overall information about the bean, such as its displayName, its customizer, etc. May return null if the information should be obtained by automatic analysis.

    - #### getPropertyDescriptors

          public PropertyDescriptor[] getPropertyDescriptors()

      Deny knowledge of properties. You can override this if you wish to provide explicit property info.
      Specified by:
        `getPropertyDescriptors` in interface `BeanInfo`
      Returns:
        an array of `PropertyDescriptor`s describing all properties supported by the bean or `null`

    - #### getDefaultPropertyIndex

          public int getDefaultPropertyIndex()

      Deny knowledge of a default property. You can override this if you wish to define a default property for the bean.
      Specified by:
        `getDefaultPropertyIndex` in interface `BeanInfo`
      Returns:
        Index of default property in the PropertyDescriptor array returned by getPropertyDescriptors.

        Returns -1 if there is no default property.

    - #### getEventSetDescriptors

          public EventSetDescriptor[] getEventSetDescriptors()

      Deny knowledge of event sets. You can override this if you wish to provide explicit event set info.
      Specified by:
        `getEventSetDescriptors` in interface `BeanInfo`
      Returns:
        An array of EventSetDescriptors describing the kinds of events fired by this bean. May return null if the information should be obtained by automatic analysis.

    - #### getDefaultEventIndex

          public int getDefaultEventIndex()

      Deny knowledge of a default event. You can override this if you wish to define a default event for the bean.
      Specified by:
        `getDefaultEventIndex` in interface `BeanInfo`
      Returns:
        Index of default event in the EventSetDescriptor array returned by getEventSetDescriptors.

        Returns -1 if there is no default event.

    - #### getMethodDescriptors

          public MethodDescriptor[] getMethodDescriptors()

      Deny knowledge of methods. You can override this if you wish to provide explicit method info.
      Specified by:
        `getMethodDescriptors` in interface `BeanInfo`
      Returns:
        An array of MethodDescriptors describing the externally visible methods supported by this bean. May return null if the information should be obtained by automatic analysis.

    - #### getAdditionalBeanInfo

          public BeanInfo[] getAdditionalBeanInfo()

      Claim there are no other relevant BeanInfo objects. You may override this if you want to (for example) return a BeanInfo for a base class.
      Specified by:
        `getAdditionalBeanInfo` in interface `BeanInfo`
      Returns:
        an array of BeanInfo objects. May return null.

    - #### getIcon

          public Image getIcon(int iconKind)

      Claim there are no icons available. You can override this if you want to provide icons for your bean.
      Specified by:
        `getIcon` in interface `BeanInfo`
      Parameters:
        `iconKind` - The kind of icon requested. This should be one of the constant values ICON_COLOR_16x16, ICON_COLOR_32x32, ICON_MONO_16x16, or ICON_MONO_32x32.
      Returns:
        An image object representing the requested icon. May return null if no suitable icon is available.

    - #### loadImage

          public Image loadImage(String resourceName)

      This is a utility method to help in loading icon images. It takes the name of a resource file associated with the current object's class file and loads an image object from that file. Typically images will be GIFs.

      Parameters:
        `resourceName` - A pathname relative to the directory holding the class file of the current class. For example, "wombat.gif".
      Returns:
        an image object. May be null if the load failed.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2019, Oracle and/or its affiliates. All rights reserved.